/// <reference types="react" />
import { Stylesheet } from "stylable";
export declare type Pojo<T = any> = {
    [key: string]: T;
} & object;
export declare type PartialStyle = any;
export declare type SBComponentProps = {
    className?: string | Pojo<boolean>;
    cssStates?: Pojo<boolean>;
    style?: PartialStyle;
};
export declare type SBStatelessComponent<T> = React.StatelessComponent<T & SBComponentProps> & {
    stylesheet: Stylesheet;
};
export declare type StylableComponent<T> = T & React.ComponentClass<SBComponentProps> & {
    stylesheet: Stylesheet;
};
export declare type StateLess<T, C> = (props: T, context: C) => JSX.Element | null;
