"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require('react');
function classNames() {
    var nodes = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        nodes[_i] = arguments[_i];
    }
    return nodes.filter(function (x) { return !!x; }).join(' ');
}
exports.classNames = classNames;
/**
 *
 * wrapSBRender is super super naive approach to create the component and highly experimental
 * but it works for testing....;)
 */
function wrapSBRender(renderFunction, sheet) {
    var createEl = createStylableCreateElement(sheet);
    var Component = function (props, context) {
        props = props || this.props || {};
        context = context || this.context || {};
        var ReactSpooned = React;
        var sbCreateElement = ReactSpooned.createElement;
        var root = null;
        try {
            ReactSpooned.createElement = createEl;
            root = renderFunction.call(this, props, context);
            root = root && React.cloneElement(root, __assign({}, sheet.cssStates(__assign({}, root.props.cssStates, props.cssStates)), { className: classNames(sheet.get(sheet.root), root.props.className, props.className), style: __assign({}, root.props.style, props.style) }));
        }
        finally {
            ReactSpooned.createElement = sbCreateElement;
        }
        return root;
    };
    Component.stylesheet = sheet;
    return Component;
}
exports.wrapSBRender = wrapSBRender;
var originalCreateElement = React.createElement;
function createStylableCreateElement(sheet) {
    return function stylableCreateElement(type, props) {
        var children = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            children[_i - 2] = arguments[_i];
        }
        if (props) {
            if (typeof props.className === 'string') {
                props.className = props.className.split(' ').map(function (name) { return sheet.get(name) || name; }).join(' ');
            }
            else if (typeof props.className === 'object') {
                props.className = Object.keys(props.className)
                    .filter(function (className) { return props.className[className]; })
                    .map(function (name) { return sheet.get(name) || name; }).join(' ');
            }
            if (typeof type === 'string' && props.cssStates) {
                var cssStates = props.cssStates, otherProps = __rest(props, ["cssStates"]);
                props = __assign({}, sheet.cssStates(cssStates), otherProps);
            }
        }
        return originalCreateElement.apply(void 0, [type, props].concat(children));
    };
}
//# sourceMappingURL=wrap-render.js.map