"use strict";
/* all comment are related to the stylable js runtime mode no need to do anything here yet! */
Object.defineProperty(exports, "__esModule", { value: true });
var wrap_render_1 = require("./wrap-render");
function SBComponent(Base, stylesheet) {
    if (!stylesheet) {
        return function (Component) {
            return SBComponent(Component, Base);
        };
    }
    var sheet = stylesheet.$stylesheet || stylesheet;
    var Class = Base;
    Class.prototype.render = wrap_render_1.wrapSBRender(Class.prototype.render, sheet);
    return Class;
}
exports.SBComponent = SBComponent;
function SBStateless(renderFunction, stylesheet) {
    var sheet = stylesheet.$stylesheet || stylesheet;
    var wrapped = wrap_render_1.wrapSBRender(renderFunction, sheet);
    return wrapped;
}
exports.SBStateless = SBStateless;
function defineMixin(name, mixinFunction) {
    var mixinId = "@Mixins/" + name;
    mixinFunction.toString = function () { return mixinId; };
    return mixinFunction;
}
exports.defineMixin = defineMixin;
//# sourceMappingURL=stylable-react.js.map